/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define BASEDIR_C_
#define BASE_FRIEND_
#include "basedir.h"

struct base *first_base, *last_base, *current_base;

void del_base(struct base *p)
{
	struct base *bj;
	struct man *mj, *mj2;
	if (!p) {
		first_base = last_base = current_base = 0;
		return;
	}

	for (bj = first_base; bj; bj = bj->next)
		if (bj->next == p) {
			bj->next = p->next;
			break;
		}

	if (p == first_base)
		first_base = p->next;
	if (p == last_base) 
		last_base = bj;
		
	for (mj = p->first; mj; ) {
		mj2 = mj->next;
		del_man(mj);
		mj = mj2;
	}
	unlink(p->name);
	xfree(p->name);
	xfree(p);
}

void add_base(char *name)
{
	struct base *b = malloc(sizeof(struct base));
	b->next = 0;
	b->name = strdup(name);
	b->data = VIRGIN;
	if (first_base) {
		last_base->next = b;
		last_base = b;
	} else
		last_base = first_base = b;
}

static int init_basedir(char *dir_name)
{
	DIR *where;
	struct dirent *j;
	char *c_dn = xgetcwd();
	char *tmp_dn;
	
	if (!dir_name)
		return 0;
	
	if (!(where = opendir(dir_name))) {
		errmsgf("Couldn`t open dir %s", dir_name);
		return 0;
	}
	
	for (chdir(dir_name); (j = readdir(where));) {
		if (*j->d_name == '.' || !strcmp("core", j->d_name))
			continue;
		tmp_dn = strdglue(dir_name, j->d_name);
		add_base(tmp_dn);
		xfree(tmp_dn);
	}
	chdir(c_dn);
	xfree(c_dn);
	return 1;
}
static struct base *find_base_by_name(char *name)
{
	struct base *b = first_base;
	int len = strlen(basedir_name) +1;
	for (; b; b = b->next)
		if (strcmp(b->name + len, name) == 0)
			break;
	return b;
}

void set_basepointers(void)
{
	if (!current_base)
		return;
	current_base->first = first_man;   
	current_base->last = last_man;  
	current_base->current =	current_man;
	current_base->data = CHANGED;
}

void set_manpointers(void)
{
	if (!current_base)
		return;
	first_man = current_base->first;
	last_man = current_base->last;
	current_man = current_base->current;
}

void clear_manpointers(void)
{
	first_man = last_man = current_man = 0;
}

int read_basedir()
{
	if (!init_basedir(basedir_name))
		return 0;
	msgf("Reading %s dir", basedir_name);
	for (current_base = first_base; current_base; SWITCH(current_base)) {
		if (read_base(current_base->name)) {
			set_basepointers();
			current_base->data = VIRGIN;
			msgf("Done for   [%s]", current_base->name);
			clear_manpointers();
		} else 
			msgf("Failed for [%s]", current_base->name);
	}

	if (!first_base) {
		msgf("this dir is empty ", ":(");
		return 0;
	}
	if (!(current_base = find_base_by_name("main"))) {
		errmsgf("Cannot find main base file", 0);
		current_base = first_base;
	}
	set_manpointers();

	return 1;	
}

void write_basedir(void)
{
	if (!first_base)
		return;
		
	set_basepointers();
	msgf("", 0);
	
	for (current_base = first_base; current_base; SWITCH(current_base)) {
		if (current_base->data == VIRGIN)
			continue;
		set_manpointers();
		write_base(current_base->name); 
	}
}
