/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define SCRPEOPLE_C_
#include "scrpeople.h"

struct tobj *bar_people;
	
void scrpeople_hide()
{
	wchoice_hide();
	wtext_hide();
	winfo_hide();
	wchoice_hide();
	wload_hide();
	whelp_hide();
	wsearch_hide();
	wpeople_hide();
	
	tobj_rhide(bar_people);
}

void scrpeople_show()
{
	scrpeople_hide();

	winfo_show();
	wpeople_show();
	
	tobj_show(bar_people);
	tset(bar_people, TOBJ_ACTIVEABLE, 0);
}

void scrpeople_refresh()
{
	long n;
	mpeople_get(TLIST_ACTIVE, &n);
	scroll_men(n);
	winfo_fill(return_man());
	scrpeople_show();
}

static void keys(struct tevent *e)
{
	
	if (tobj_doevent(bar_people, e->data))
		return;
	if (barkeys_service(e->data))
		return;
	if (wpeople_service(e))
		return;
	if (wsearch_service(e))
		return;
	if (wtext_service(e))
		return;
	if (wload_service(e))
		return;
	if (wchoice_service(e))
		return;
	if (whelp_service(e))
		return;

	switch (e->data) {
	case K_RIGHT:
		scr_change();
		break;
	}
}

struct scr *scrpeople_create()
{
	struct scr *screen = xmalloc(sizeof(struct scr));
	screen->keys = keys;
	screen->refresh = scrpeople_refresh;
	screen->hide = scrpeople_hide;
	screen->show = scrpeople_show;
	return screen;
}

static void scrchange_b(struct tobj *obj, long data)
{
	(void) obj;
	(void) data;
	scr_change();
}

static void addman_b(struct tobj *obj, long data)
{
	(void) data;
	(void) obj;

	if (!current_base && !base_name) {
		wmsg("First, you have to add some data-base");	
		newbase_b(0, 0);
		return;
	}
	add_new_man();
	mpeople_additem("noname");
	current_man = last_man;
	mpeople_domethod(TLIST_ACTIVATE_LAST, 0);
	scr_change();
}

void delman_b(struct tobj *obj, long data)
{
	long n;
	
	(void) obj;

	mpeople_get(TLIST_ACTIVE, &n);
	mpeople_domethod(TLIST_ENTRY_DEL, n);

	if (data == 3)
		del_man_from_list(current_man);
	else 
		del_man(current_man);

	mpeople_get(TLIST_ACTIVE, &n);
	scroll_men(n);
	winfo_fill(return_man());
}

static void quit_b(struct tobj *obj, long data)
{
	(void) data;
	(void) obj;

	if (whelp_isshowing() || 
		wload_isshowing() || wsearch_isshowing()) 
		scrpeople_show();
	else 
		quit_otak();
}

#define ADD_HTOOL(fnc,key) add_tool(bar_people, fnc, key, "", TTOOL_HIDDEN)
#define ADD_TOOL(fnc,key,txt) add_tool(bar_people, fnc, key, translate(txt), 0)
#define ADD_INFO(txt) add_tool(bar_people, 0, 0, translate(txt), TTOOL_INFO)
static int barpeople_create(struct tobj *rootwin)
{
	if (!(bar_people = ttoolbar_init(rootwin, toolbar_up)))
		return 0;
	if (!ADD_TOOL(scrchange_b, *edit_key, "edit"))
		return 0;
	if (!ADD_TOOL(addman_b, *add_key, "add"))
		return 0;
	if (!ADD_TOOL(delman_b, *del_key, "delete"))
		return 0;
	if (!ADD_TOOL(quit_b, *quit_key, "quit"))
		return 0;
	if (!ADD_TOOL(help_b, 'h', "help"))
		return 0;
	if (!ADD_TOOL(search_b, '/', "search"))
		return 0;
	if (!ADD_HTOOL(help_b, '?'))
		return 0;
	if (!ADD_INFO(" "))
		return 0;
	if (!ADD_HTOOL(moveman_b, *move_key))
		return 0;
	if (!ADD_HTOOL(loadbase_b, *load_key))
		return 0;
	if (!ADD_HTOOL(newbase_b, 'N'))
		return 0;
	if (!ADD_HTOOL(delbase_b, 'D'))
		return 0;
	
	return 1;
}



int scrpeople_obj_create(struct tobj *rootwin)
{
	if (!barpeople_create(rootwin))
		return 0;

	if (!wpeople_create(rootwin))
		return 0;
		
	if (!wload_create(rootwin))
		return 0;
		
	if (!wsearch_create(rootwin))
		return 0;

	return 1;
}


void scrpeople_obj_free(void)
{
	wload_free();
	wsearch_free();
	wpeople_free();

	tobj_free(bar_people);
	bar_people = NULL;
}

