/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define WEDIT_C_
#include "wedit.h"

static struct tobj *win_edit, *line_edit;
extern int edit_mode;

int wedit_service(struct tevent *e)
{
	if (e->sender != line_edit && e->sender != win_edit)
		return 0;
	switch (e->data) {
	case EVENT_TINPUT_ACCEPT:
		if (edit_mode)
			mdata_domethod(TLIST_ACTIVATE_NEXT, 0);
		editmode_service();
		return 1;
	case EVENT_TINPUT_REJECT:
		ledit_reject();
		scrdata_refresh();
		edit_mode = 0;
		return 1;
	}
	
	return 0;
}
void wedit_settitle(char *name)
{
	tset(win_edit, TWIN_TITLE, (long)translate(name));
}

void wedit_show()
{
	tobj_show(win_edit);
}

void wedit_hide()
{
	tobj_rhide(win_edit);
}

int ledit_flush()
{
	int reinit = (line_edit) ? 1 : 0;
	if (reinit)
		tobj_free(line_edit);
	if (!(line_edit = tinput_init(win_edit, 1, 1, 
		get_w(Wedit)-2, "", 100))) {
		if (reinit)
			errexit("Cannot reinit line eidit.\n");
		return 0;
	}
	return 1;
}

void ledit_fill(char *s)
{
	do
		tobj_domethod(line_edit, TINPUT_PUT_CHAR, *s);
	while (*s++);
}

void ledit_reject()
{
	if (!current_drawer)
		return;
		
	if (!current_drawer->last->caption) 
		del_item(current_drawer, current_drawer->last);				
	if (!current_drawer->first)
		del_drawer(current_man, current_drawer);
	
	ledit_flush();
}
/* service of line_edit caption
 * if it is empty - deleteing
 * if it was changed - wraitng to srtuct man
 * if there was no drawer - adding one and put caption */
void ledit_service()
{
	long n;
	char *str = (char *)txget(line_edit, TINPUT_BUFFER_CURRENT);

	if (!current_drawer) {
		if (*str)
			add_drawer(current_man, current_stanza, str);
	} else if (!current_drawer->last->caption) {
		if (*str) 
			current_drawer->last->caption = strdup(str);
		else
			del_item(current_drawer, current_drawer->last);				
	} else {
		struct item *ij = current_drawer->first;
		if (ij->next) {
			n = mchoice_len();
			while (n--)
				ij = ij->next;
		}
		if (*str)
			ij->caption = strdup(str);
		else
			del_item(current_drawer, ij);
	}

	if (current_drawer && !current_drawer->first)
		del_drawer(current_man, current_drawer);
	
	ledit_flush();
}

int wedit_create(struct tobj *rootwin)
{
	DEFINE_SIZES(Wedit);
	if (!(win_edit = twin_init(rootwin, x, y, w, h, translate("edit"))))
		return 0;

	if (!ledit_flush())
		return 0;
		
        tset(win_edit, TOBJ_HIDDEN, 1);
	
	return 1;
}

void wedit_free(void)
{
	set_size(Wedit, win_edit);
	tobj_free(win_edit);
	win_edit = line_edit = NULL;
}

